# Othello research support AI app Egaroucid

<a href="https://twitter.com/share?ref_src=twsrc%5Etfw" class="twitter-share-button" data-text="Othello research support AI app Egaroucid" data-url="https://www.egaroucid-app.nyanyan.dev/" data-hashtags="egaroucid" data-related="takuto_yamana,Nyanyan_Cube" data-show-count="false">Tweet</a><script async src="https://platform.twitter.com/widgets.js" charset="utf-8"></script> <a href=./../ja/>日本語</a>

## What is Egaroucid?

Egaroucid is an Othello app with one of the strongest othello solver AI. 

The light version got the first place in the world ([CodinGame Othello](https://www.codingame.com/multiplayer/bot-programming/othello-1/leaderboard)) as of February, 2022.

![Display](./../img/app_en.png)

 

## Functions

* Play against AI
* Analyze games
* Show various evaluation values
* Input & Output
* Create & modify book automatically or manually
* Add Egaroucid's or Edax's book
* Show Joseki (in Japanese)



## Download

[Here](https://github.com/Nyanyan/Egaroucid5/releases) you can download.

Please select the OS, then click to download.

Unzip the zip to anywhere, then click ```Egaroucid5.exe``` to execute. For MacOS users, please see below.

![download](./../img/download.png)



### How to open in MacOS

Only version 5.4.1 can be used in MacOS. Egaroucid5.4.1 has a trouble in opening.

To open it, please

```
cd path/to/Egaroucid
chmod Egaroucid.app/Contents/MacOS/Egaroucid
```

Then please execute ```Egaroucid.app/Contents/MacOS/Egaroucid```.

Now fixing this problem.



## Usage

[Here](./../usage/) you can see.

You can also download manuals in [markdown format](./../usage/en/index.md) or [PDF format](./../usage/en/index.pdf).



## Play against the light version which got 1st in the world

[Here](https://www.egaroucid.nyanyan.dev/) in Japanese you can play against the light version which got the first place in the world.

![egaroucid light](./../img/egaroucid_light.png)



## Benchmarks

[Here](./../benchmark/) you can see.



## Technologies

[Here](./../technology/) you can see technologies used in this AI.



## Acknowledgments

I would like to thank these people for great contributions.

### UI Design

Kaneko Eizo

### User Test

okojoMK

Takada Seigo

madaranuko

Nagano Yasushi

trineutron

Kuruton



## Creator

Takuto Yamana / Nyanyan



## Links

* [GitHub Repository](https://github.com/Nyanyan/Egaroucid5)
* [Creator's Twitter (Quiet)](https://twitter.com/takuto_yamana)
* [Creator's Twitter (Noisy)](https://twitter.com/Nyanyan_Cube)
* [Creator's Web Page](https://nyanyan.github.io/)

